import { __decorate, __extends, __values, __assign, __awaiter, __generator, __param } from 'tslib';
import { ElementRef, HostBinding, Input, Output, Component, forwardRef, EventEmitter, ɵɵdefineInjectable, ɵɵinject, Injectable, ViewContainerRef, Attribute, TemplateRef, ViewChild, ComponentFactoryResolver, ApplicationRef, Injector, INJECTOR, Directive, Self, Renderer2, HostListener, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR, NgModel } from '@angular/forms';
import { BehaviorSubject, of, Subject, merge, fromEvent } from 'rxjs';
import { take, finalize, filter, takeUntil, debounceTime, tap, takeWhile, distinctUntilChanged, map } from 'rxjs/operators';
import { NavigationEnd, ActivatedRoute, Router, RouterModule } from '@angular/router';
import { CommonModule } from '@angular/common';

var ImageInputValue = /** @class */ (function () {
    function ImageInputValue() {
    }
    return ImageInputValue;
}());
var ImageInputComponent = /** @class */ (function () {
    function ImageInputComponent(elementRef) {
        this.elementRef = elementRef;
        this.randomId = btoa(Math.random().toString());
        this.bootstrap = true;
        this.draggedOver = false;
        this.disabled = false;
        this.interactive = true;
        this.bgImage = '';
        this.valueChange = new BehaviorSubject(this.value);
        this.onChangeFn = function (x) { return null; };
    }
    ImageInputComponent_1 = ImageInputComponent;
    Object.defineProperty(ImageInputComponent.prototype, "hasImage", {
        get: function () {
            return !!this.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageInputComponent.prototype, "placeholderValue", {
        set: function (value) {
            this.originalValue = value;
            if (value && value.src) {
                this.bgImage = "url(" + value.src + ")";
            }
            else {
                this.bgImage = '';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageInputComponent.prototype, "value", {
        get: function () {
            return this.originalValue;
        },
        set: function (value) {
            var _this = this;
            if (this.disabled) {
                return;
            }
            if (this.modifier) {
                this.disabled = true;
                of(value)
                    .pipe(this.modifier, take(1), finalize(function () {
                    _this.disabled = false;
                }))
                    .subscribe(function (v) {
                    _this.disabled = false;
                    _this.originalValue = v;
                    _this.onChangeFn(v);
                    _this.valueChange.next(v);
                    _this.bgImage = "url(" + v.src + ")";
                });
                return;
            }
            this.originalValue = value;
            this.onChangeFn(value);
            this.valueChange.next(value);
            this.bgImage = "url(" + value.src + ")";
        },
        enumerable: true,
        configurable: true
    });
    ImageInputComponent.prototype.ngOnInit = function () {
    };
    ImageInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeFn = fn;
    };
    ImageInputComponent.prototype.registerOnTouched = function (fn) {
    };
    ImageInputComponent.prototype.writeValue = function (obj) {
        if (this.disabled || !obj) {
            return;
        }
        this.originalValue = obj;
        this.bgImage = "url(" + obj.src + ")";
    };
    ImageInputComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    ImageInputComponent.prototype.fileChange = function ($event) {
        var _this = this;
        var target = ($event.target);
        var files = (target.files || $event.dataTransfer.files);
        if (files.length) {
            var reader_1 = new FileReader();
            reader_1.onload = function () {
                var value = new ImageInputValue();
                value.blob = files.item(0);
                value.src = reader_1.result;
                value.id = btoa(Math.random().toString());
                _this.value = value;
                target.value = null;
            };
            reader_1.readAsDataURL(files.item(0));
        }
        else {
            // this.hasImage = false;
            // this.value = {};
        }
    };
    var ImageInputComponent_1;
    ImageInputComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        HostBinding('class.form-control')
    ], ImageInputComponent.prototype, "bootstrap", void 0);
    __decorate([
        HostBinding('class.dragging-over')
    ], ImageInputComponent.prototype, "draggedOver", void 0);
    __decorate([
        HostBinding('class.has-image')
    ], ImageInputComponent.prototype, "hasImage", null);
    __decorate([
        HostBinding('class.disabled'), Input()
    ], ImageInputComponent.prototype, "disabled", void 0);
    __decorate([
        HostBinding('class.interactive'), Input()
    ], ImageInputComponent.prototype, "interactive", void 0);
    __decorate([
        Input()
    ], ImageInputComponent.prototype, "placeholderValue", null);
    __decorate([
        Input()
    ], ImageInputComponent.prototype, "value", null);
    __decorate([
        Output()
    ], ImageInputComponent.prototype, "valueChange", void 0);
    __decorate([
        Input()
    ], ImageInputComponent.prototype, "modifier", void 0);
    ImageInputComponent = ImageInputComponent_1 = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'image-input',
            template: "<div class=\"image\" [style.backgroundImage]=\"bgImage\"></div>\r\n<input type=\"file\"\r\n       accept=\"image/png, image/jpeg\"\r\n       (change)=\"fileChange($event)\"\r\n       (dragenter)=\"draggedOver = true\"\r\n       (dragover)=\"draggedOver = true\"\r\n       (dragend)=\"draggedOver = false\"\r\n       (dragleave)=\"draggedOver = false\"\r\n       (drop)=\"draggedOver = false; fileChange($event)\"\r\n       [id]=\"randomId\">\r\n<label [for]=\"randomId\">\r\n  <svg aria-hidden=\"true\" focusable=\"false\" data-prefix=\"fas\" data-icon=\"file-upload\" role=\"img\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 384 512\" class=\"svg-inline--fa fa-file-upload fa-w-12 fa-3x\"><path fill=\"#909090\" d=\"M224 136V0H24C10.7 0 0 10.7 0 24v464c0 13.3 10.7 24 24 24h336c13.3 0 24-10.7 24-24V160H248c-13.2 0-24-10.8-24-24zm65.18 216.01H224v80c0 8.84-7.16 16-16 16h-32c-8.84 0-16-7.16-16-16v-80H94.82c-14.28 0-21.41-17.29-11.27-27.36l96.42-95.7c6.65-6.61 17.39-6.61 24.04 0l96.42 95.7c10.15 10.07 3.03 27.36-11.25 27.36zM377 105L279.1 7c-4.5-4.5-10.6-7-17-7H256v128h128v-6.1c0-6.3-2.5-12.4-7-16.9z\" class=\"\"></path></svg>\r\n</label>\r\n",
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return ImageInputComponent_1; }),
                    multi: true
                }],
            styles: [":host{min-width:200px;min-height:200px;position:relative;display:flex;padding:0;background-color:rgba(0,0,0,.1)}:host .image{background-size:contain;background-repeat:no-repeat;background-position:center center;height:100%!important;width:100%!important;flex:1;position:absolute}:host input[type=file]{height:100%!important;width:100%!important;border:0!important;margin:0!important;padding:0!important;position:absolute;flex:1;opacity:0;-webkit-filter:opacity(0);filter:opacity(0);cursor:pointer}:host label{display:flex;flex:1;max-height:100%;flex-direction:column;position:relative;margin:0!important;pointer-events:none}:host label svg{flex:1;height:0;min-height:50px;margin:auto}:host.dragging-over label{background:rgba(0,0,0,.2)}:host.has-image label{-webkit-filter:opacity(0);filter:opacity(0)}:host.has-image label svg{-webkit-filter:brightness(130%);filter:brightness(130%)}:host.has-image.dragging-over label,:host.has-image:hover label{-webkit-filter:opacity(1);filter:opacity(1);background:rgba(0,0,0,.2);display:flex}:host.disabled input,:host.disabled label{display:none!important;pointer-events:none!important}:host:not(.interactive) input,:host:not(.interactive) label{pointer-events:none;display:none}"]
        })
    ], ImageInputComponent);
    return ImageInputComponent;
}());

var GalleryImageValue = /** @class */ (function (_super) {
    __extends(GalleryImageValue, _super);
    function GalleryImageValue() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return GalleryImageValue;
}(ImageInputValue));
var ImageGalleryComponent = /** @class */ (function () {
    function ImageGalleryComponent() {
        var _this = this;
        this.disabled = false;
        this.bootstrap = true;
        this.valueChange = new BehaviorSubject(this.value);
        this.delete = new EventEmitter();
        this.randomId = btoa(Math.random().toString());
        this.index = -1;
        this.originalValue = [
        // {
        //   src: 'https://source.unsplash.com/random',
        //   sort: 0
        // },
        // {
        //   src: 'https://source.unsplash.com/random',
        //   sort: 1
        // },
        // {
        //   src: 'https://source.unsplash.com/random',
        //   sort: 2
        // },
        // {
        //   src: 'https://source.unsplash.com/random',
        //   sort: 2
        // },
        ];
        this.dir = 'ltr';
        this.onChangeFn = function (x) { return null; };
        var targetNode = window.document.documentElement;
        var config = { attributes: true, childList: false, subtree: false };
        var callback = function (mutationsList, observer) {
            var e_1, _a;
            try {
                // Use traditional 'for loops' for IE 11
                for (var mutationsList_1 = __values(mutationsList), mutationsList_1_1 = mutationsList_1.next(); !mutationsList_1_1.done; mutationsList_1_1 = mutationsList_1.next()) {
                    var mutation = mutationsList_1_1.value;
                    if (mutation.type === 'attributes') {
                        _this.dir = targetNode.getAttribute('dir') || 'ltr';
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (mutationsList_1_1 && !mutationsList_1_1.done && (_a = mutationsList_1.return)) _a.call(mutationsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        this.htmlElementObserver = new MutationObserver(callback);
        this.htmlElementObserver.observe(targetNode, config);
    }
    ImageGalleryComponent_1 = ImageGalleryComponent;
    Object.defineProperty(ImageGalleryComponent.prototype, "value", {
        get: function () {
            return this.originalValue;
        },
        set: function (value) {
            if (this.disabled) {
                return;
            }
            this.originalValue = value.sort(function (a, b) { return a.sort - b.sort; });
            this.onChangeFn(value);
            this.valueChange.next(value);
            if (!this.selected && value.length) {
                this.selected = this.originalValue[0];
            }
        },
        enumerable: true,
        configurable: true
    });
    ImageGalleryComponent.prototype.ngOnDestroy = function () {
        this.htmlElementObserver.disconnect();
    };
    ImageGalleryComponent.prototype.registerOnChange = function (fn) {
        this.onChangeFn = fn;
    };
    ImageGalleryComponent.prototype.registerOnTouched = function (fn) {
    };
    ImageGalleryComponent.prototype.writeValue = function (obj) {
        if (!obj) {
            return;
        }
        this.originalValue = obj.sort(function (a, b) { return a.sort - b.sort; });
        if (!this.selected && obj.length) {
            this.selected = this.originalValue[0];
        }
    };
    ImageGalleryComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    ImageGalleryComponent.prototype.newImage = function ($event) {
        if (!$event) {
            return;
        }
        var newImage = __assign(__assign({}, $event), { sort: this.value.length });
        this.originalValue.push(newImage);
        this.value = this.originalValue;
        this.selected = newImage;
    };
    ImageGalleryComponent.prototype.deleteImage = function (index) {
        this.delete.next({ index: index, images: this.originalValue, deleted: this.originalValue[index] });
        delete this.originalValue[index];
        for (var i = index; i < this.originalValue.length - 1; i++) {
            this.originalValue[i] = this.originalValue[i + 1];
            this.originalValue[i].sort = i;
        }
        if (this.value.length) {
            if (index > 0) {
                this.selected = this.originalValue[index];
            }
            else {
                this.selected = this.originalValue[index - 1];
            }
        }
        else {
            this.selected = null;
        }
        this.originalValue.splice(this.originalValue.length - 1, 1);
        this.value = this.originalValue;
    };
    ImageGalleryComponent.prototype.swapImages = function (aIndex, bIndex) {
        if (!this.originalValue[aIndex] || !this.originalValue[bIndex]) {
            return;
        }
        var temp = this.originalValue[aIndex];
        this.originalValue[aIndex] = this.originalValue[bIndex];
        this.originalValue[bIndex] = temp;
        for (var i = 0; i < this.originalValue.length; i++) {
            this.originalValue[i].sort = i;
        }
    };
    var ImageGalleryComponent_1;
    __decorate([
        HostBinding('class.disabled'), Input()
    ], ImageGalleryComponent.prototype, "disabled", void 0);
    __decorate([
        HostBinding('class.form-control')
    ], ImageGalleryComponent.prototype, "bootstrap", void 0);
    __decorate([
        Output()
    ], ImageGalleryComponent.prototype, "valueChange", void 0);
    __decorate([
        Output()
    ], ImageGalleryComponent.prototype, "delete", void 0);
    __decorate([
        Input()
    ], ImageGalleryComponent.prototype, "imageInputModifier", void 0);
    ImageGalleryComponent = ImageGalleryComponent_1 = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'image-gallery',
            template: "<div class=\"d-flex\">\r\n  <ng-container *ngIf=\"value.length > 1\">\r\n    <button type=\"button\" class=\"btn btn-light\" (click)=\"swapImages(selected.sort, selected.sort - 1)\" *ngIf=\"!this.disabled\">\r\n      <i\r\n        class=\"fas fa-fw fa-chevron-left\"\r\n        *ngIf=\"dir === 'rtl'\"></i>\r\n      <i\r\n        class=\"fas fa-fw fa-chevron-right\"\r\n        *ngIf=\"dir === 'ltr'\"></i>\r\n    </button>\r\n    <span class=\"mx-1 my-auto\">\r\n    {{selected?.sort + 1}}\r\n      <small> / {{value.length}}</small>\r\n    </span>\r\n    <button type=\"button\" class=\"btn btn-light\" (click)=\"swapImages(selected.sort, selected.sort + 1)\" *ngIf=\"!this.disabled\">\r\n      <i\r\n        class=\"fas fa-fw fa-chevron-right\"\r\n        *ngIf=\"dir === 'rtl'\"></i>\r\n      <i\r\n        class=\"fas fa-fw fa-chevron-left\"\r\n        *ngIf=\"dir === 'ltr'\"></i>\r\n    </button>\r\n  </ng-container>\r\n  <div class=\"flex-grow-1\"></div>\r\n  <button type=\"button\"\r\n          (click)=\"deleteImage(selected.sort)\"\r\n          class=\"btn btn-danger\" *ngIf=\"value.length && !this.disabled\">\r\n    <i class=\"fas fa-fw fa-trash\"></i>\r\n  </button>\r\n</div>\r\n<image-input\r\n  [placeholderValue]=\"selected\"\r\n  [disabled]=\"disabled\"\r\n  [modifier]=\"imageInputModifier\"\r\n  (valueChange)=\"newImage($event)\"\r\n  class=\"flex-grow-1 mt-1\"\r\n></image-input>\r\n<div class=\"row flex-nowrap gallery-slider p-md-4 p-2 mx-n2 \" *ngIf=\"value.length > 1\">\r\n  <div class=\"col-md-4 slide-item d-flex flex-column px-1\" *ngFor=\"let image of value; let i = index\">\r\n    <div class=\"bg-white rounded position-relative flex-grow-1 clickable shadow-sm\"\r\n         [class.shadow]=\"image.id === selected.id\"\r\n         (click)=\"selected = image\">\r\n      <div class=\"image\" [style.backgroundImage]=\"'url(' + image.src + ')'\"></div>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return ImageGalleryComponent_1; }),
                    multi: true
                }],
            styles: [":host{min-width:200px;min-height:300px;position:relative;display:flex;flex-direction:column}:host .gallery-slider{overflow-x:auto}:host .gallery-slider .slide-item{min-height:100px;min-width:100px}:host .gallery-slider .slide-item .image{background-size:contain;background-repeat:no-repeat;background-position:center center;height:100%!important;width:100%!important;flex-grow:1;position:absolute}"]
        })
    ], ImageGalleryComponent);
    return ImageGalleryComponent;
}());

var BreadcrumbsService = /** @class */ (function () {
    function BreadcrumbsService(activatedRoute, router) {
        var _this = this;
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.breadcrumbs$ = new BehaviorSubject([]);
        router.events
            .pipe(filter(function (event) { return event instanceof NavigationEnd; })).subscribe(function () {
            _this.breadcrumbs$.next(_this.digBreadcrumbs(activatedRoute.root.snapshot));
        });
    }
    BreadcrumbsService.prototype.digBreadcrumbs = function (route, breadcrumbs) {
        if (breadcrumbs === void 0) { breadcrumbs = []; }
        var _a, _b;
        var config = route.routeConfig;
        if ((config === null || config === void 0 ? void 0 : config.breadcrumb) || ((_a = config === null || config === void 0 ? void 0 : config.data) === null || _a === void 0 ? void 0 : _a.breadcrumb)) {
            breadcrumbs.push({
                label: (config === null || config === void 0 ? void 0 : config.breadcrumb) || ((_b = config === null || config === void 0 ? void 0 : config.data) === null || _b === void 0 ? void 0 : _b.breadcrumb),
                url: '/' + route.pathFromRoot.map(function (o) { return o.url[0]; }).filter(function (u) { return !!(u === null || u === void 0 ? void 0 : u.path); }).join('/'),
                index: breadcrumbs.length,
            });
        }
        if (route.firstChild) {
            return this.digBreadcrumbs(route.firstChild, breadcrumbs);
        }
        return breadcrumbs;
    };
    BreadcrumbsService.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Router }
    ]; };
    BreadcrumbsService.ɵprov = ɵɵdefineInjectable({ factory: function BreadcrumbsService_Factory() { return new BreadcrumbsService(ɵɵinject(ActivatedRoute), ɵɵinject(Router)); }, token: BreadcrumbsService, providedIn: "any" });
    BreadcrumbsService = __decorate([
        Injectable({
            providedIn: 'any',
        })
    ], BreadcrumbsService);
    return BreadcrumbsService;
}());

var BreadcrumbsComponent = /** @class */ (function () {
    function BreadcrumbsComponent(vRef, breadcrumbsService) {
        this.vRef = vRef;
        this.breadcrumbsService = breadcrumbsService;
        this.breadcrumbListClass = '';
        this.breadcrumbListItemClass = '';
    }
    BreadcrumbsComponent.prototype.ngOnInit = function () {
    };
    BreadcrumbsComponent.prototype.ngAfterContentInit = function () {
    };
    BreadcrumbsComponent.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: BreadcrumbsService }
    ]; };
    __decorate([
        Input()
    ], BreadcrumbsComponent.prototype, "linkTemplate", void 0);
    __decorate([
        Attribute('breadcrumbListClass'), Input()
    ], BreadcrumbsComponent.prototype, "breadcrumbListClass", void 0);
    __decorate([
        Attribute('breadcrumbListItemClass'), Input()
    ], BreadcrumbsComponent.prototype, "breadcrumbListItemClass", void 0);
    BreadcrumbsComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'nav[breadcrumbs]',
            template: "<ol class=\"breadcrumb {{breadcrumbListClass}}\">\n  <li class=\"breadcrumb-item {{breadcrumbListItemClass}}\" *ngFor=\"let breadcrumb of breadcrumbsService.breadcrumbs$ | async\" routerLinkActive=\"active\">\n    <ng-container *ngTemplateOutlet=\"linkTemplate || templateRef; context: breadcrumb\"></ng-container>\n  </li>\n</ol>\n\n<ng-template #templateRef let-label=\"label\" let-url=\"url\" let-index=\"index\">\n  <a [routerLink]=\"url\" routerLinkActive=\"active\" [routerLinkActiveOptions]=\"{exact: true}\">{{label}}</a>\n</ng-template>\n",
            styles: [""]
        })
    ], BreadcrumbsComponent);
    return BreadcrumbsComponent;
}());

var popoverStyleElement = "\n  <style>\n    popover-container {\n        position: fixed;\n        top: 0;\n        left: 0;\n        z-index: 2000;\n    }\n\n    popover-container flying-popover {\n        position: absolute;\n        left: 0;\n        top: 0;\n        z-index: 0;\n        background-color: #fff;\n        will-change: transform;\n        filter: opacity(0);\n        pointer-events: none;\n        border-radius: 0.25rem;\n        border-color: white;\n    }\n\n    popover-container flying-popover.show {\n        filter: opacity(1) drop-shadow(0 0 0.5rem rgba(0, 0, 0, 0.3));\n        pointer-events: auto;\n    }\n\n    popover-container flying-popover::before {\n        content: '';\n        display: block;\n        border-color: inherit;\n        position: absolute;\n        z-index: -1;\n    }\n\n    popover-container flying-popover.arrow.top-left {\n        border-bottom-right-radius: 0;\n        margin-top: -.5rem;\n    }\n\n    popover-container flying-popover.arrow.top-left::before {\n        top: calc(100%);\n        left: calc(100% - .5rem);\n        border-bottom: .5rem solid transparent;\n        border-right: .5rem solid;\n        border-right-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.bottom-left {\n        border-top-right-radius: 0;\n        margin-top: .5rem;\n    }\n\n    popover-container flying-popover.arrow.bottom-left::before {\n        bottom: calc(100%);\n        left: calc(100% - .5rem);\n        border-top: .5rem solid transparent;\n        border-right: .5rem solid;\n        border-right-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.middle-left {\n        margin-left: -.5rem;\n    }\n\n    popover-container flying-popover.arrow.middle-left::before {\n        top: calc(50% - 0.25rem);\n        left: calc(100%);\n        border-top: .25rem solid transparent;\n        border-bottom: .25rem solid transparent;\n        border-left: .5rem solid;\n        border-left-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.top-right {\n        border-bottom-left-radius: 0;\n        margin-top: -.5rem;\n    }\n\n    popover-container flying-popover.arrow.top-right::before {\n        top: calc(100%);\n        right: calc(100% - .5rem);\n        border-bottom: .5rem solid transparent;\n        border-left: .5rem solid;\n        border-left-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.bottom-right {\n          border-top-left-radius: 0;\n          margin-top: .5rem;\n    }\n\n    popover-container flying-popover.arrow.bottom-right::before {\n        bottom: calc(100%);\n        right: calc(100% - .5rem);\n        border-top: .5rem solid transparent;\n        border-left: .5rem solid;\n        border-left-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.middle-right {\n        margin-left: .5rem;\n    }\n\n    popover-container flying-popover.arrow.middle-right::before {\n        top: calc(50% - 0.25rem);\n        right: calc(100%);\n        border-top: .25rem solid transparent;\n        border-bottom: .25rem solid transparent;\n        border-right: .5rem solid;\n        border-right-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.bottom-center {\n        margin-top: .5rem;\n    }\n\n    popover-container flying-popover.arrow.bottom-center::before {\n        bottom: calc(100%);\n        left: calc(50% - .25rem);\n        border-left: .25rem solid transparent;\n        border-right: .25rem solid transparent;\n        border-bottom: .5rem solid;\n        border-bottom-color: inherit;\n    }\n\n    popover-container flying-popover.arrow.top-center {\n        margin-top: -.5rem;\n    }\n\n    popover-container flying-popover.arrow.top-center::before {\n        top: calc(100%);\n        left: calc(50% - .25rem);\n        border-left: .25rem solid transparent;\n        border-right: .25rem solid transparent;\n        border-top: .5rem solid;\n        border-top-color: inherit;\n    }\n\n    popover-container flying-popover .popover-body {\n        padding: .5rem;\n        width: max-content;\n    }\n  </style>\n";
var Popover = /** @class */ (function () {
    function Popover(_a) {
        var content = _a.content, anchorElement = _a.anchorElement, horizontal = _a.horizontal, vertical = _a.vertical, element = _a.element, popoverComponentRef = _a.popoverComponentRef;
        this.arrowClassValue = 'arrow';
        this.arrowClass = this.arrowClassValue;
        this.showValue = false;
        this.forceShow = false;
        this.customClass = '';
        this.matchWidth = false;
        this.ready = new Subject();
        if (element) {
            this.element = element;
        }
        else if (popoverComponentRef) {
            this.popoverComponentRef = popoverComponentRef;
            this.element = popoverComponentRef.hostView.rootNodes[0];
        }
        else {
            this.element = document.createElement('flying-popover');
        }
        this.id = btoa(Math.random().toString());
        this.anchorElement = anchorElement;
        this.content = content;
        this.horizontal = horizontal || this.horizontal;
        this.vertical = vertical || this.vertical;
        this.ready.next(this);
        this.ready = of(this);
    }
    Object.defineProperty(Popover.prototype, "show", {
        get: function () {
            return this.showValue || this.forceShow;
        },
        set: function (showValue) {
            this.showValue = showValue;
            this.updatePopOverPosition();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popover.prototype, "arrow", {
        set: function (b) {
            this.arrowClass = b ? this.arrowClassValue : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popover.prototype, "content", {
        set: function (content) {
            var _this = this;
            if (typeof content === 'string') {
                this.element.innerHTML = "<div class=\"popover-body\">" + content + "</div>";
            }
            else if (content instanceof HTMLElement) {
                this.element.innerHTML = "";
                this.element.appendChild(content);
            }
            else if (Array.isArray(content)) {
                this.element.innerHTML = "";
                content.forEach(function (c) {
                    if (c instanceof HTMLElement) {
                        _this.element.appendChild(c);
                    }
                });
            }
            else if (content instanceof TemplateRef && this.popoverComponentRef) {
                this.popoverComponentRef.instance.setContent(content);
            }
        },
        enumerable: true,
        configurable: true
    });
    Popover.prototype.getPosition = function () {
        var anchorRect = this.anchorElement.getBoundingClientRect();
        if (this.matchWidth === 'min-width') {
            this.element.style.minWidth = anchorRect.width + 'px';
        }
        else if (this.matchWidth) {
            this.element.style.width = anchorRect.width + 'px';
        }
        else {
            delete this.element.style.width;
        }
        var popoverRect = this.element.getBoundingClientRect();
        var horizontal = this.horizontal;
        var vertical = this.vertical;
        var top = anchorRect.top;
        var left = anchorRect.left;
        var rtl = document.documentElement.getAttribute('dir') === 'rtl';
        switch (horizontal) {
            case 'center':
                left += (anchorRect.width * .5) - (popoverRect.width * .5);
                break;
            case 'start':
                left += rtl ? anchorRect.width + popoverRect.width : -popoverRect.width;
                horizontal = rtl ? 'right' : 'left';
                break;
            case 'end':
                left += rtl ? -popoverRect.width : anchorRect.width;
                horizontal = rtl ? 'left' : 'right';
                break;
            case 'left':
                left += -popoverRect.width;
                break;
            case 'right':
                left += anchorRect.width;
                break;
            case 'left-baseline':
                left += 0;
                horizontal = 'right';
                break;
            case 'right-baseline':
                left += anchorRect.width - popoverRect.width;
                horizontal = 'left';
                break;
            case 'start-baseline':
                left += rtl ? anchorRect.width - popoverRect.width : 0;
                horizontal = rtl ? 'left' : 'right';
                break;
            case 'end-baseline':
                left += rtl ? 0 : anchorRect.width - popoverRect.width;
                horizontal = rtl ? 'right' : 'left';
                break;
            case 'auto':
                if (!rtl) {
                    if (left + anchorRect.width >= window.innerWidth) {
                        left += -popoverRect.width;
                        horizontal = 'left';
                    }
                    else {
                        left += anchorRect.width;
                        horizontal = 'right';
                    }
                }
                else {
                    if (left < 0) {
                        left += anchorRect.width;
                        horizontal = 'right';
                    }
                    else {
                        left += -popoverRect.width;
                        horizontal = 'left';
                    }
                }
                break;
        }
        left = Math.max(0, Math.min(window.innerWidth - popoverRect.width, left));
        left = left + 'px';
        switch (vertical) {
            case 'middle':
                top += (anchorRect.height * .5) - (popoverRect.height * .5);
                break;
            case 'top':
                top += -popoverRect.height;
                break;
            case 'bottom':
                top += anchorRect.height;
                break;
            case 'top-baseline':
                top += 0;
                break;
            case 'bottom-baseline':
                top += anchorRect.height - popoverRect.height;
                break;
            case 'auto':
                if (top + anchorRect.height + popoverRect.height > window.innerHeight) {
                    top += -popoverRect.height;
                    vertical = 'top';
                }
                else {
                    top += anchorRect.height;
                    vertical = 'bottom';
                }
                break;
        }
        top = Math.max(0, Math.min(window.innerHeight - popoverRect.height, top));
        top = top + 'px';
        return {
            top: top,
            left: left,
            horizontal: horizontal,
            vertical: vertical,
        };
    };
    Popover.prototype.updatePopOverPosition = function () {
        var _this = this;
        var position = this.getPosition();
        requestAnimationFrame(function () {
            _this.element.style.transform = "translate(" + position.left + ", " + position.top + ")";
            _this.element.className = _this.show ?
                "show " + position.vertical + "-" + position.horizontal + " " + _this.customClass + " " + _this.arrowClass
                : _this.customClass;
        });
    };
    return Popover;
}());
var FlyingPopoverComponent = /** @class */ (function () {
    function FlyingPopoverComponent() {
        this.content$ = new BehaviorSubject(null);
        this.ngDestroy$ = new Subject();
    }
    FlyingPopoverComponent.prototype.setContent = function (template) {
        this.content$.next(template);
    };
    FlyingPopoverComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.content$
            .pipe(takeUntil(this.ngDestroy$), filter(function (template) { return template; }))
            .subscribe(function (template) {
            _this.container.clear();
            _this.container.createEmbeddedView(template);
        });
    };
    FlyingPopoverComponent.prototype.ngOnDestroy = function () {
        this.ngDestroy$.next();
    };
    __decorate([
        ViewChild('container', { static: true, read: ViewContainerRef })
    ], FlyingPopoverComponent.prototype, "container", void 0);
    FlyingPopoverComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'flying-popover',
            template: '<ng-template #container></ng-template>',
            styles: ['']
        })
    ], FlyingPopoverComponent);
    return FlyingPopoverComponent;
}());
var PopoverService = /** @class */ (function () {
    function PopoverService(componentFactoryResolver, appRef, injector) {
        var _this = this;
        this.componentFactoryResolver = componentFactoryResolver;
        this.appRef = appRef;
        this.injector = injector;
        this.popovers = [];
        this.underObservation = [];
        this.containerElement = document.createElement('popover-container');
        this.containerElement.innerHTML = (popoverStyleElement);
        document.body.append(this.containerElement);
        merge(fromEvent(window, 'scroll', { capture: true }), fromEvent(window, 'resize')
            .pipe(debounceTime(1000)))
            .subscribe(function () {
            _this.underObservation.forEach(function (popover) { return popover.updatePopOverPosition(); });
        });
    }
    PopoverService.prototype.addPopover = function (popover) {
        return __awaiter(this, void 0, void 0, function () {
            var popoverComponentRef, service, newPopover;
            return __generator(this, function (_a) {
                popoverComponentRef = this.componentFactoryResolver.resolveComponentFactory(FlyingPopoverComponent).create(this.injector);
                this.appRef.attachView(popoverComponentRef.hostView);
                delete popover.element;
                popover.popoverComponentRef = popoverComponentRef;
                service = this;
                newPopover = new Proxy(new Popover(popover), {
                    set: function (target, p, value) {
                        if (p === 'show') {
                            target[p] = value;
                            if (!target.show) {
                                var index = service.underObservation.findIndex(function (pop) { return pop.id === target.id; });
                                if (index > -1) {
                                    service.underObservation.splice(index, 1);
                                }
                            }
                            else {
                                var index = service.underObservation.findIndex(function (pop) { return pop.id === target.id; });
                                if (index === -1) {
                                    service.underObservation.push(target);
                                }
                            }
                        }
                        target[p] = value;
                        return true;
                    }
                });
                this.containerElement.append(popoverComponentRef.hostView.rootNodes[0]);
                this.popovers.push(newPopover);
                if (!newPopover.show) {
                    this.underObservation.push(newPopover);
                }
                newPopover.updatePopOverPosition();
                return [2 /*return*/, (newPopover)];
            });
        });
    };
    PopoverService.prototype.removePopover = function (id) {
        var index = this.popovers.findIndex(function (pop) { return pop.id === id; });
        var index2 = this.underObservation.findIndex(function (pop) { return pop.id === id; });
        if (index !== -1) {
            this.popovers[index].element.remove();
            delete this.popovers[index];
            this.popovers.splice(index, 1);
        }
        if (index2 !== -1) {
            delete this.underObservation[index];
            this.underObservation.splice(index, 1);
        }
    };
    PopoverService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector }
    ]; };
    PopoverService.ɵprov = ɵɵdefineInjectable({ factory: function PopoverService_Factory() { return new PopoverService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: PopoverService, providedIn: "root" });
    PopoverService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], PopoverService);
    return PopoverService;
}());

var PopoverDirective = /** @class */ (function () {
    function PopoverDirective(popoverService, elementRef) {
        this.popoverService = popoverService;
        this.elementRef = elementRef;
        this.ngDestroy$ = new Subject();
        this.popoverContentValue$ = new BehaviorSubject('');
        this.popoverOnHook = '';
        this.popoverPlacementValue = {
            horizontal: 'auto',
            vertical: 'auto',
        };
        this.popoverClassValue = '';
        this.popoverArrowValue = true;
        this.popoverMatchWidthValue = false;
    }
    Object.defineProperty(PopoverDirective.prototype, "popoverContent", {
        set: function (content) {
            this.popoverContentValue$.next(content);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopoverDirective.prototype, "popoverOn", {
        set: function (hook) {
            if (hook === this.popoverOnHook) {
                return;
            }
            this.popoverOnHook = hook;
            this.updateHook();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopoverDirective.prototype, "popoverPlacement", {
        set: function (popoverPlacementValue) {
            var _a;
            this.popoverPlacementValue = popoverPlacementValue;
            (_a = this.popover) === null || _a === void 0 ? void 0 : _a.updatePopOverPosition();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopoverDirective.prototype, "popoverClass", {
        set: function (customClass) {
            this.popoverClassValue = customClass;
            if (this.popover) {
                this.popover.customClass = customClass;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopoverDirective.prototype, "popoverArrow", {
        set: function (customArrow) {
            this.popoverArrowValue = customArrow;
            if (this.popover) {
                this.popover.arrow = customArrow;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopoverDirective.prototype, "popoverMatchWidth", {
        set: function (matchWidth) {
            this.popoverMatchWidthValue = matchWidth;
            if (this.popover) {
                this.popover.matchWidth = matchWidth;
            }
        },
        enumerable: true,
        configurable: true
    });
    PopoverDirective.prototype.show = function () {
        this.popover.show = true;
    };
    PopoverDirective.prototype.hide = function () {
        this.popover.show = false;
    };
    PopoverDirective.prototype.forceShow = function (bool) {
        if (bool === void 0) { bool = true; }
        this.popover.forceShow = bool;
        this.popover.updatePopOverPosition();
    };
    PopoverDirective.prototype.ngAfterContentInit = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.popoverService.addPopover({
                                anchorElement: this.elementRef.nativeElement,
                                content: this.popoverContentValue$.value,
                                vertical: this.popoverPlacementValue.vertical,
                                horizontal: this.popoverPlacementValue.horizontal,
                            })];
                    case 1:
                        _a.popover = _b.sent();
                        this.popover.customClass = this.popoverClassValue;
                        this.popover.arrow = this.popoverArrowValue;
                        this.popover.matchWidth = this.popoverMatchWidthValue;
                        setTimeout(function () { return _this.popover.updatePopOverPosition(); }, 1000);
                        this.updateHook();
                        this.popoverContentValue$
                            .pipe(takeUntil(this.ngDestroy$), tap(function (elements) { return _this.popover.content = elements; }))
                            .subscribe();
                        return [2 /*return*/];
                }
            });
        });
    };
    PopoverDirective.prototype.updateHook = function () {
        if (!this.popover) {
            return;
        }
        switch (this.popoverOnHook) {
            case 'hover':
                this.activateOnHover();
                break;
            case 'click':
                this.activateOnClick();
                break;
        }
    };
    PopoverDirective.prototype.activateOnHover = function () {
        var _this = this;
        fromEvent(this.popover.element, 'mouseover', { capture: true })
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'hover'; }), tap(function () { return _this.popover.forceShow = true; }))
            .subscribe();
        fromEvent(this.popover.element, 'mouseleave')
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'hover'; }), tap(function () { return _this.popover.forceShow = false; }), tap(function () { return _this.popover.updatePopOverPosition(); }))
            .subscribe();
        fromEvent(this.elementRef.nativeElement, 'mouseover', { capture: true })
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'hover'; }))
            .subscribe(function () { return _this.popover.show = true; });
        fromEvent(this.elementRef.nativeElement, 'mouseleave')
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'hover'; }))
            .subscribe(function () { return _this.popover.show = false; });
        fromEvent(window, 'click')
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'hover'; }))
            .subscribe(function (event) {
            return !_this.popover.element.contains(event.target) ?
                _this.popover.show = _this.popover.forceShow = false
                : null;
        });
    };
    PopoverDirective.prototype.activateOnClick = function () {
        var _this = this;
        fromEvent(this.elementRef.nativeElement, 'click')
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'click'; }))
            .subscribe(function () { return _this.popover.show = !_this.popover.show; });
        fromEvent(window, 'click')
            .pipe(takeUntil(this.ngDestroy$), takeWhile(function () { return _this.popoverOnHook === 'click'; }))
            .subscribe(function (event) {
            return !_this.popover.element.contains(event.target)
                &&
                    !_this.elementRef.nativeElement.contains(event.target)
                ? _this.popover.show = _this.popover.forceShow = false
                : null;
        });
    };
    PopoverDirective.prototype.ngOnDestroy = function () {
        var _a;
        this.ngDestroy$.next();
        this.popoverService.removePopover((_a = this.popover) === null || _a === void 0 ? void 0 : _a.id);
    };
    PopoverDirective.ctorParameters = function () { return [
        { type: PopoverService },
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverContent", null);
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverOn", null);
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverPlacement", null);
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverClass", null);
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverArrow", null);
    __decorate([
        Input()
    ], PopoverDirective.prototype, "popoverMatchWidth", null);
    PopoverDirective = __decorate([
        Directive({
            // tslint:disable-next-line:directive-selector
            selector: '[popover]',
            exportAs: 'popover'
        })
    ], PopoverDirective);
    return PopoverDirective;
}());

var PressAndHoldEvent = /** @class */ (function (_super) {
    __extends(PressAndHoldEvent, _super);
    function PressAndHoldEvent() {
        return _super.call(this, 'pressandhold') || this;
    }
    return PressAndHoldEvent;
}(Event));
function pressAndHoldEventInit(element, delay) {
    if (delay === void 0) { delay = 500; }
    var ev = new PressAndHoldEvent();
    var frame;
    var pressDown = function () {
        element.dispatchEvent(ev);
        var time = performance.now();
        var pressHold = function () {
            if (time + delay <= performance.now()) {
                element.dispatchEvent(ev);
            }
            frame = requestAnimationFrame(pressHold);
        };
        frame = requestAnimationFrame(pressHold);
    };
    var pressUp = function () {
        cancelAnimationFrame(frame);
    };
    element.addEventListener('touchstart', pressDown, false);
    element.addEventListener('touchend', pressUp, false);
    element.addEventListener('touchcancel', pressUp, false);
    element.addEventListener('mousedown', pressDown, false);
    element.addEventListener('mouseup', pressUp, false);
    element.addEventListener('mouseleave', pressUp, false);
}

var numberRegex = /(?:[-+]?\d+\.?\d*)|[\s-+*/]/g;
var AdvanceInputDirective = /** @class */ (function () {
    function AdvanceInputDirective(model, elementRef, renderer) {
        this.model = model;
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.forceType = 'text';
        this.ngDestroy$ = new Subject();
        this.prefixValue = '';
        this.suffixValue = '';
        this.cursorPosition = 0;
        this.model.valueAccessor.registerOnChange = function registerOnChange(fn) {
            this.onChange = fn;
        };
    }
    Object.defineProperty(AdvanceInputDirective.prototype, "type", {
        set: function (type) {
            this.typeValue = type;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AdvanceInputDirective.prototype, "prefix", {
        set: function (prefix) {
            this.prefixValue = prefix;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AdvanceInputDirective.prototype, "suffix", {
        set: function (suffix) {
            this.suffixValue = suffix;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AdvanceInputDirective.prototype, "controls", {
        set: function (controls) {
            var _a, _b;
            this.controlsValue = controls;
            if (this.typeValue === 'number') {
                if (this.controlsValue && this.element) {
                    this.initializeControls();
                }
                else {
                    (_a = this.incrementElement) === null || _a === void 0 ? void 0 : _a.remove();
                    (_b = this.decrementElement) === null || _b === void 0 ? void 0 : _b.remove();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    AdvanceInputDirective.prototype.updateValue = function (value) {
        if (value === void 0) { value = ''; }
        var _a;
        value = (value + '').replace(new RegExp('^' + this.prefixValue), '');
        value = (value + '').replace(new RegExp(this.suffixValue + '&'), '');
        switch (this.typeValue) {
            case 'number':
                value = value.replace(/(\s)+/g, '$1');
                value = value.replace(/([^-+*/]|\s)([-+*/])+/g, '$1$2');
                value = value.replace(/(\s[-+*/]\s)[-+*/]/g, '$1');
                // remove the repetition of the left edge zeros of numbers
                value = value.replace(/^([\s]*)(0)+/g, '$1$2');
                value = value.replace(/([^\d.])(0)+/g, '$1$2');
                // remove the left edge zeros of numbers
                value = value.replace(/^([\s]*)(?:0|(0\.))([\d]+)/g, '$1$2$3');
                value = value.replace(/([^\d.])(?:0|(0\.))([\d]+)/g, '$1$2$3');
                value = (_a = value.match(numberRegex)) === null || _a === void 0 ? void 0 : _a.join('');
                value = !isNaN(this.min) && !isNaN(+value) ? Math.max(+value, this.min) + '' : value;
                value = !isNaN(this.max) && !isNaN(+value) ? Math.min(+value, this.max) + '' : value;
                if (value !== undefined && value.match(/^\s*[-+]?(?:\d+|\d+\.\d+)$/g) && !value.match(/^\s*[-+]?(?:\d+\.\d*0)$/g)) {
                    value = value !== '' ? parseFloat(value) : undefined;
                    value = isNaN(value) ? undefined : value;
                }
                break;
        }
        this.value = value;
        this.model.control.setValue(this.prefixValue
            + ([null, undefined].includes(this.value) ? '' : this.value)
            + this.suffixValue, { emitEvent: false });
        this.model.control.setValue(this.value, { emitViewToModelChange: true, emitModelToViewChange: false });
        return this.value;
    };
    AdvanceInputDirective.prototype.forceCursor = function ($event) {
        if (($event === null || $event === void 0 ? void 0 : $event.type) === 'select') {
            $event.preventDefault();
        }
        this.cursorPosition = this.element.selectionStart;
        var cursorPositionEnd = this.element.selectionEnd;
        this.cursorPosition = Math.max(this.prefixValue.length, this.cursorPosition);
        this.cursorPosition = Math.min(this.element.value.length - this.suffixValue.length, this.cursorPosition);
        cursorPositionEnd = Math.max(this.prefixValue.length, cursorPositionEnd);
        cursorPositionEnd = Math.min(this.element.value.length - this.suffixValue.length, cursorPositionEnd);
        this.element.setSelectionRange(this.cursorPosition, cursorPositionEnd, this.element.selectionDirection);
    };
    AdvanceInputDirective.prototype.evalValue = function ($event) {
        var _a;
        if (($event.type === 'keydown' && $event.key === 'Enter') || $event.type === 'blur') {
            switch (this.typeValue) {
                case 'number':
                    var value = this.value;
                    try {
                        // tslint:disable-next-line:no-eval
                        this.updateValue(eval(this.value));
                    }
                    catch (e) {
                        this.updateValue((_a = (this.value + '' || '').match(/(?:[-+]?\d+\.?\d*)/)) === null || _a === void 0 ? void 0 : _a.join(''));
                    }
                    if (+value !== +this.value) {
                        if ($event.type === 'keydown') {
                            $event.stopPropagation();
                            $event.preventDefault();
                        }
                    }
                    break;
            }
        }
    };
    AdvanceInputDirective.prototype.onKeyDown = function ($event) {
        this.forceCursor($event);
        this.evalValue($event);
        switch (this.typeValue) {
            case 'number':
                if (['ArrowUp', 'ArrowDown'].includes($event.key)) {
                    $event.preventDefault();
                    $event.stopPropagation();
                    $event.stopImmediatePropagation();
                    var multiplier = 1;
                    if ($event.altKey) {
                        multiplier = 0.1;
                    }
                    else {
                        multiplier = $event.metaKey || $event.ctrlKey ? multiplier * 10 : multiplier;
                        multiplier = $event.shiftKey ? multiplier * 100 : multiplier;
                    }
                    if ($event.key === 'ArrowUp') {
                        this.updateValue(((this.value * 10) + (multiplier * 10)) / 10);
                    }
                    if ($event.key === 'ArrowDown') {
                        this.updateValue(((this.value * 10) - (multiplier * 10)) / 10);
                    }
                    $event.preventDefault();
                    this.cursorPosition = this.prefixValue.length;
                    var cursorPositionEnd = this.element.value.length - this.suffixValue.length;
                    this.element.setSelectionRange(this.cursorPosition, cursorPositionEnd, 'none');
                }
                break;
        }
    };
    AdvanceInputDirective.prototype.initializeControls = function () {
        var _this = this;
        var _a, _b;
        if (this.incrementElement && this.decrementElement) {
            return;
        }
        (_a = this.incrementElement) === null || _a === void 0 ? void 0 : _a.remove();
        (_b = this.decrementElement) === null || _b === void 0 ? void 0 : _b.remove();
        this.incrementElement = this.renderer.createElement('div');
        this.decrementElement = this.renderer.createElement('div');
        this.incrementElement.className = this.decrementElement.className = 'input-group-append';
        this.element.parentElement.append(this.decrementElement, this.incrementElement);
        var incrementButton = this.renderer.createElement('button');
        incrementButton.innerHTML = "<i class=\"fas fa-sm fa-plus fa-fw\"></i>";
        this.incrementElement.appendChild(incrementButton);
        var decrementButton = this.renderer.createElement('button');
        decrementButton.innerHTML = "<i class=\"fas fa-sm fa-minus fa-fw\"></i>";
        this.decrementElement.appendChild(decrementButton);
        incrementButton.className = decrementButton.className = 'btn btn-sm btn-primary';
        incrementButton.type = decrementButton.type = 'button';
        pressAndHoldEventInit(incrementButton);
        pressAndHoldEventInit(decrementButton);
        incrementButton.addEventListener('pressandhold', function () { return _this.updateValue(_this.value + 1); });
        decrementButton.addEventListener('pressandhold', function () { return _this.updateValue(_this.value - 1); });
    };
    AdvanceInputDirective.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.element = this.elementRef.nativeElement;
        this.element.autocomplete = 'off';
        this.element.type = 'text';
        if (!this.element.classList.contains('form-control')) {
            this.element.classList.add('form-control');
        }
        if (!this.element.parentElement.classList.contains('input-group')) {
            var parent_1 = this.element.parentNode;
            var inputGroup = this.renderer.createElement('div');
            this.renderer.addClass(inputGroup, 'input-group');
            this.renderer.appendChild(inputGroup, this.element);
            this.renderer.appendChild(parent_1, inputGroup);
        }
        this.controls = this.controlsValue;
        this.model.valueChanges
            .pipe(takeUntil(this.ngDestroy$), distinctUntilChanged(), map(function (value) { return _this.updateValue(value); }))
            .subscribe();
    };
    AdvanceInputDirective.prototype.ngOnDestroy = function () {
        this.ngDestroy$.next();
    };
    AdvanceInputDirective.ctorParameters = function () { return [
        { type: NgModel, decorators: [{ type: Self }] },
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    __decorate([
        Attribute('type'), Input()
    ], AdvanceInputDirective.prototype, "type", null);
    __decorate([
        Attribute('prefix'), Input()
    ], AdvanceInputDirective.prototype, "prefix", null);
    __decorate([
        Attribute('suffix'), Input()
    ], AdvanceInputDirective.prototype, "suffix", null);
    __decorate([
        Attribute('controls'), Input()
    ], AdvanceInputDirective.prototype, "controls", null);
    __decorate([
        Attribute('min'), Input()
    ], AdvanceInputDirective.prototype, "min", void 0);
    __decorate([
        Attribute('max'), Input()
    ], AdvanceInputDirective.prototype, "max", void 0);
    __decorate([
        Attribute('type'), HostBinding('type')
    ], AdvanceInputDirective.prototype, "forceType", void 0);
    __decorate([
        HostListener('focus'),
        HostListener('click'),
        HostListener('select', ['$event'])
    ], AdvanceInputDirective.prototype, "forceCursor", null);
    __decorate([
        HostListener('blur', ['$event'])
    ], AdvanceInputDirective.prototype, "evalValue", null);
    __decorate([
        HostListener('keydown', ['$event'])
    ], AdvanceInputDirective.prototype, "onKeyDown", null);
    AdvanceInputDirective = __decorate([
        Directive({
            // tslint:disable-next-line:directive-selector
            selector: 'input[advanceInput]',
        }),
        __param(0, Self())
    ], AdvanceInputDirective);
    return AdvanceInputDirective;
}());

var ImageInputComponentsModule = /** @class */ (function () {
    function ImageInputComponentsModule() {
    }
    ImageInputComponentsModule = __decorate([
        NgModule({
            declarations: [ImageInputComponent, ImageGalleryComponent],
            imports: [
                CommonModule,
            ],
            exports: [ImageInputComponent, ImageGalleryComponent],
        })
    ], ImageInputComponentsModule);
    return ImageInputComponentsModule;
}());
var PopoverModule = /** @class */ (function () {
    function PopoverModule() {
    }
    PopoverModule = __decorate([
        NgModule({
            declarations: [PopoverDirective],
            imports: [CommonModule],
            exports: [PopoverDirective],
        })
    ], PopoverModule);
    return PopoverModule;
}());
var AdvanceInputModule = /** @class */ (function () {
    function AdvanceInputModule() {
    }
    AdvanceInputModule = __decorate([
        NgModule({
            declarations: [AdvanceInputDirective],
            imports: [CommonModule],
            exports: [AdvanceInputDirective],
        })
    ], AdvanceInputModule);
    return AdvanceInputModule;
}());
var BreadcrumbsModule = /** @class */ (function () {
    function BreadcrumbsModule() {
    }
    BreadcrumbsModule = __decorate([
        NgModule({
            declarations: [BreadcrumbsComponent],
            imports: [CommonModule, RouterModule],
            exports: [BreadcrumbsComponent],
        })
    ], BreadcrumbsModule);
    return BreadcrumbsModule;
}());
var NabbousBootstrapComponentsModule = /** @class */ (function () {
    function NabbousBootstrapComponentsModule() {
    }
    NabbousBootstrapComponentsModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                ImageInputComponentsModule,
                AdvanceInputModule,
                PopoverModule,
                BreadcrumbsModule,
            ],
            exports: [
                ImageInputComponentsModule,
                AdvanceInputModule,
                PopoverModule,
                BreadcrumbsModule,
            ]
        })
    ], NabbousBootstrapComponentsModule);
    return NabbousBootstrapComponentsModule;
}());

/*
 * Public API Surface of nabbous-bootstrap-components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AdvanceInputDirective, AdvanceInputModule, BreadcrumbsComponent, BreadcrumbsModule, BreadcrumbsService, GalleryImageValue, ImageGalleryComponent, ImageInputComponent, ImageInputComponentsModule, ImageInputValue, NabbousBootstrapComponentsModule, Popover, PopoverDirective, PopoverModule, PopoverService };
//# sourceMappingURL=monabbous-ng-bootstrap-components.js.map
