import { ActivatedRoute, ActivatedRouteSnapshot, Route, Router } from '@angular/router';
import { BehaviorSubject } from 'rxjs';
export interface Breadcrumb {
    label: string;
    url: string;
    index: number;
}
export interface BreadcrumbRoute extends Route {
    breadcrumb?: string;
    children?: BreadcrumbRoute[];
}
export declare type BreadcrumbRoutes = BreadcrumbRoute[];
export declare class BreadcrumbsService {
    activatedRoute: ActivatedRoute;
    router: Router;
    breadcrumbs$: BehaviorSubject<Breadcrumb[]>;
    constructor(activatedRoute: ActivatedRoute, router: Router);
    digBreadcrumbs(route: ActivatedRouteSnapshot, breadcrumbs?: Breadcrumb[]): any;
}
